enum
{
	mysqlCREATE = 0,
	mysqlDROP,
	mysqlINSERT,			
	mysqlDELETE,			
	mysqlUPDATE,			
	mysqlSELECT,
	mysqlUSE,
	mysqlALTER,
	mysqlSHOW
};

enum {
 DATABASE = 1,
 TABLE = 2,
 QUERY = 3
};

struct dbResults {
	int numOfDbResults;
	struct dbResult *result;
};

// Type:  MYSQL_RESULT == 0, ORACLE_RESULT == 1
struct dbResult {
	int type;
	void* resultObj;
};

struct mysqlResult {
	int test;
	void* result;
};
typedef struct mysqlResult mysqlResult;
typedef struct mysqlResult * pmysqlResult;

struct databaseObject {
	int type;
	void* dbObject;
};
typedef struct databaseObject databaseObject;
typedef struct databaseObject * pdatabaseObject;

struct dbQueries {
	int numOfQueries;
	struct dbQuery* query;
};

struct dbQuery {
	int type;
	void* queryObject;
};

struct mysqlObject {
	int type;
	void* myobject; // Can be typecasted to either mysqlDatabase or mysqlTable or mysqlQuery
};
typedef struct mysqlObject mysqlObject;
typedef struct mysqlObject * pmysqlObject;

/*
struct query {
	int command;
	int object;
	int tableType;
	char* subject;
	char* fields; 
	char** values; 
	struct fieldvalue *fv;
	char** query;
	char **newValues;
	int numOfValues;
};
*/

struct dbConnectMysql {
	MYSQL *conn;
	char*	host;
	char*	user;
	char*	pass;
	char*	db;
//	unsigned int port;
//	char*	unix_socket;
//	unsigned long client_flag;
//	struct query *q;
};
typedef struct dbConnectMysql dbConnectMysql;
typedef struct dbConnectMysql * pdbConnectMysql;

struct dbNewConnect {
	int dbType;
	void* dbConnection;
	struct pNPdatabases *dbList;
};
typedef struct dbNewConnect dbNewConnect;
typedef struct dbNewConnect * pdbNewConnect;

struct dbConnect {
	char*	host;
	char*	user;
	char*	pass;
	char*	db;
	unsigned int port;
	char*	unix_socket;
	unsigned long client_flag;
	void *conn;
	struct query *q;
};


struct csvNode 
{
	int size;
	char *csvStr;
};

struct csvNodes
{
	int numOfNodes;
	int totalCsvSize;
	struct csvNode *node;
};

/*
struct chunkObj {
	int numOfStrings;
	char **str;
};
*/
 
struct chunkObj {
	int chunkSize;
	struct csvNodes *nodes;
};

struct chunksObj {
	int numOfChunks;
	struct chunkObj *chunk;
};

// Could make all these mysql Structures more generic, as in arrays of void*'s
struct mysqlQuery {
	char query[400][67000]; // 3000 to 400 for first index, 67000 to 5000 for second index, debug db
	int command;
	int object;
	int tableType;
	int conditionalType;
//	char* subject;
	char* fields; 
	struct chunksObj *values;
//	struct fieldvalue *fv;
	char conditionals[500]; // Temp shrinking size of conditional array to 500, debug db
	int numberOfQueries;
//	char **newValues;
	int numOfValues;
	struct mysqlObject* focus;
//	MYSQL_RES *result[300]; // This will be typecasted from a void* to a MYSQL_RES
	void *result[150];
	int numOfResults;
};
typedef struct mysqlQuery mysqlQuery;
typedef struct mysqlQuery * pmysqlQuery;
 
struct mysqlTable {
	char* name;
	char* fields;
	//char** values;
	//struct chunksObj *values;
	//int numOfValues; //???
	//int numOfChunks;
	//char* formattedValues;
	int tableType;
	int fieldsSize;
	int valuesSize;
	int formattedValuesSize;	
};

struct mysqlDatabase {
	char* name;
};